'From Smalltalk-80 version 0.4d1(32) of February 19th, 1987 on 23 March 1987 at 12:25:20 pm'!


!Form methodsFor: 'fileIn/Out'!
macPaintOn: stream
	"Write the form to the stream in MacPaint format." 

	| scanLineForm scanLineBits scanLineBitBlt topMargin leftMargin lineHeader |

	(width > 576) | (height > 720)
		ifTrue: [ self error: 'Form too big for MacPaint' ].
	stream nextPutAll: (ByteArray new: 512).	"The header"

	lineHeader _ Character value: 71.	"Magic number for un-compressed images"
	scanLineForm _ Form new.
	scanLineBits _ ByteArray new: 72.
	scanLineForm extent: 576@1
		offset: 0@0
		bits: scanLineBits.
	leftMargin _ ((576 - width) / 2) truncated.
	scanLineBitBlt _ BitBlt destForm: scanLineForm
		sourceForm: self
		halftoneForm: nil
		combinationRule: Form over
		destOrigin: leftMargin@0
		sourceOrigin: 0@0
		extent: width@1
		clipRect: (leftMargin@0 extent: (leftMargin+width)@1).

	topMargin _ ((720 - height) / 3) truncated.
	scanLineBitBlt sourceForm: nil; mask: Form white; copyBits.
	topMargin timesRepeat:
		[ stream nextPut: lineHeader; nextPutAll: scanLineBits. ].

	scanLineBitBlt sourceForm: self; mask: nil; copyBits.
	0 to: height - 1 do: [ :n |
		scanLineBitBlt sourceY: n; copyBits.
		stream nextPut: lineHeader; nextPutAll: scanLineBits. ].

	topMargin _ (720 - height - topMargin).
	scanLineBitBlt sourceForm: nil; mask: Form white; copyBits.
	topMargin timesRepeat:
		[ stream nextPut: lineHeader; nextPutAll: scanLineBits. ].

	(stream isKindOf: HFSMacFileStream) ifTrue:
		[ stream setType: 'PNTG' creator: 'MPNT' ]

	"To turn some rectangle on the screen into a MacPaint file do:
	| f |
	f _ FileStream fileNamed: 'STScreen0'.
	Form fromUser macPaintOn: f.
	f close.
	"! !