'From Smalltalk-80 of August 1st, 1985 on 1 January 1980 at 12:00:00 am'!


!BrowserCodeController methodsFor: 'menu messages'!
retrieve
	"Replace text with true source retrieved from one of the four original sources disks"
	| selectedClass selector newText locked |
	locked _ model isLocked.
	model messageListIndex = 0 ifTrue: [^view flash].
	selectedClass _ model selectedClassOrMetaClass.
	selector _ model selectedMessageName.
	newText _ self retrieveSourceFor: selector class: selectedClass.
	newText == nil ifTrue: [^ view flash].
	self deselect; selectInvisiblyFrom: 1 to: paragraph text size.
	self replaceSelectionWith: (newText asText makeSelectorBoldIn: selectedClass).
	self selectAt: 1.
	locked ifFalse: [self unlockModel]! !
!BrowserCodeController methodsFor: 'private'!
retrieveSourceFor: selector class: class
	"Find the true source on one of the four original sources disks"
	| method position divSize divFile sourceString |
	method _ class compiledMethodAt: selector.
	method fileIndex = 1 ifFalse: [^ nil].  "Can only do this for the orig source file"
	position _ method filePosition.
	divSize _ 393216.
	divFile _ HFSMacVolume huntFor: (position // divSize + 1) printString ,
			'.' , Smalltalk sourcesName.
	divFile = nil ifTrue: [ ^ nil "User canceled" ].
	divFile position: position\\divSize.
	sourceString _ divFile nextChunk.
	divFile close.
	^ sourceString! !

!BrowserCodeController class methodsFor: 'class initialization'!
initialize
	"BrowserCodeController initialize.
	BrowserCodeController allInstancesDo: [:c | c initializeYellowButtonMenu]. "

	BrowserCodeYellowButtonMenu _ 
		PopUpMenu labels: 
'again
undo
copy
cut
paste
doIt
printIt
format
accept
cancel
spawn
retrieve
explain' 
		lines: #(2 5 8 11).
	BrowserCodeYellowButtonMessages _ 
		#(again undo copySelection cut paste doIt printIt format accept cancel spawn retrieve explain).
	NewLine _ String with: Character cr  "used to append cr in explain messages"! !

!HFSMacVolume methodsFor: 'volume access'!
ejectQuiet
	| list |
	"Like eject, but don't close the open files, nor ask the user anything."
	^ self checkError: (Mac pbEject: pbRec)! !

!HFSMacVolume class methodsFor: 'instance manipulation'!
huntFor: fileName
	| volumes dir menu caption |
	volumes _ Set new.
	FileDirectory do: 
		[:dir |
		((dir isKindOf: self) and: [dir includesKey: fileName])
			ifTrue: [^dir oldFile: fileName]].

	menu _ PopUpMenu labels:
'retrieve
cancel'.
	caption _ ('Please insert the disk containing:
', fileName , ' then select retrieve') asText
		makeBoldFrom: 36 to: 36 + fileName size.
	[ true ] whileTrue:
		[ dir _ FileDirectory directoryNamed: 'Internal' ifUnknown: [ nil ].
		dir isNil ifFalse:
			[ (dir includesKey: fileName)
				ifTrue: [^dir oldFile: fileName]
				ifFalse: [ dir ejectQuiet ] ].
		(menu startUpWithCaption: caption) = 1 ifFalse: [ ^ nil ] ]
! !

BrowserCodeController initialize!
BrowserCodeController allInstancesDo: [:c |
	c initializeYellowButtonMenu].!
